;    SAVEBMP4     Save GVRAM to BMP 4bit (16colors)
code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; MS-DOS COM`vO
start:          jmp     main    ; ɃWv
;----------------------------- static data -----------------------------
ProgramTitle    DB  "SaveBMP4  1.30  Copyright (C) 1994,2021-23 ܂(DOSsoft)",13,10,0
align 16
OutputFileName  DB  "VRAM4BIT.BMP", 260-12 dup (0)
CRLF            DB      13,10,0,0
SizeOfHeaderPal DW      0
msg_not98       DB      "This machine is not PC-9800 series",13,10,0
err_abort       DB      "Program abnormally terminated.",13,10
                DB      "yG[zvOُ͈I܂.",13,10,0
;----------------------------- data end ---------------------------------
main:           
                mov     cx,4
                mov     bx,offset stackbase+1024        ; X^bN1024oCg
                shr     bx,cl
                add     bx,17
                mov     ah,4Ah  ; gpJ
                int 21h
                mov     ax,bx
                shl     ax,cl
                dec     ax
                mov     sp,ax           ; X^bN͂ύX

                mov     dx,offset ProgramTitle
                call    _puts
                call    machine_check   ; XWǂ̃`FbN
                mov     al,0FFh         ; G[ԒlFF
                jc      ErrExitDOS         ; L[Β~
                call    CmdParam
                jc      ErrExitDOS         ; L[Β~

                xor     ax,ax
                mov     es,ax
                mov     al,es:[0501h]   ; nC]
                test    al,8
                jnz     ErrExitDOS         ; nZF=1Β~

                call    ginit
                call    SavePalette16
                call    CheckPal
                CALL    MakeHeadPal     ; iwb_Ɓjpbgf[^̐
                                        ; wb_͒萔ŌvZς
                mov     dx,offset OutputFileName
                call    SaveToFile
                jc      ErrExitDOS
                mov     al,00h
                jmp     ExitDOS
ErrExitDOS:     mov     dx,offset err_abort
                call    _puts
                mov     al,0FFh
ExitDOS:        mov     ah,4Ch
                int 21h
;-----------------------------------------------------------
CmdParam        PROC   near
                cld
                mov     di,offset OutputFileName
                mov     si,80h
                lodsb   ;       R}hC
                or      al,al
                jz      zeroparam
                mov     cx,0
scansp:         lodsb
                cmp     al,20h     ; 󔒕XLĐi߂
                jne     @f
                inc     cx
                cmp     cx,76h     ; ^CAEg
                je      noparam
                jmp     scansp
        @@:     dec     si      ; P߂
        @@:     lodsb           ; LȕΑ
                cmp     al,'/'  ; XCb`Ƃ́A
                je      noparam
                cmp     al,'-'  ; t@C͂ȂƂ݂Ȃ
                je      noparam
                cmp     al,0Dh  ; sR[hŏI
                je      endofcmdl
                cmp     al,00h  ; nullł
                je      endofcmdl
                inc     cx
                cmp     cx,76
                je      noparam
                stosb
                jmp     @b
endofcmdl:      mov     al,0
                stosb
                mov     ax,bx
zeroparam:      
                clc
                ret
noparam:        stc
                ret
CmdParam        ENDP
;---------------------- BMP DATA struct --------------------
BitmapFileHeader        STRUC
        bfType          DW      ?
        bfSize          DD      ?
        bfResv          DD      ?
        bfOffBits       DW      ?
        bfOffBits_H     DW      ?
BitmapFileHeader        ENDS


BitmapInfoHeader        STRUC
        biSize          DD      ?
        biWidth         DD      ?
        biHeight        DD      ?
        biPlanes        DW      ?
        biBitCounts     DW      ?
        biComp          DD      ?
        biSizeImage     DD      ?
        biXreso         DD      ?
        biYreso         DD      ?
        biColorUsed     DD      ?
        biColorImp      DD      ?
BitmapInfoHeader        ENDS
;DATA_BYTE_SIZE  equ     640*400*(4/8)    ; 640~400 dot4bit (~4bit/8bit)=16000
.386
DATA_BYTE_SIZE  equ  128000 ; .386wɂȂ32bit萔lFȂ!! MASM6
.186
;----------------------------- data end ---------------------------------


;--------------------------------------------------------------
MakeHeadPal     PROC    near    ; blue,green,red,resv   98=G,R,B  BMP=B,G,R,0
                mov     ax,BF_head.bfOffBits
                mov     SizeOfHeaderPal,ax
                mov     si,offset PaletteTable98
                mov     di,offset PAL16
                mov     cx,16   ; 98palette      BMP palette
CnvPal16Ent:                    ; H<---->L        H<---->L
                                ; B|R|G|N|  ==>   0|R|G|B|
                lodsb           ; pal#
                lodsw           ; ax=R|G
                xchg    dx,ax   ; 
                lodsb           ; al=b
                stosb           ; B
                xchg    ax,dx   ; R|G
                stosw           ; R|G
                mov     al,0
                stosb           ; Z      ( Z|R|G|B )
               loop     CnvPal16Ent
                ret
MakeHeadPal     ENDP

;--------------------------------- ȉ̓X^bNϐgp
DOS_handle      equ     word ptr [bp-4]
LineCount       equ     word ptr [bp-6]
P8Count         equ     word ptr [bp-8]
;---------------------------------------------------------------
GetVram_DXAX    PROC   near
                push    ds
                mov     ds,cs:SegE000   ; bxVRAM̃ItZbg                 
                mov     dh,ds:[bx]      ; VRAM1oCg(8dot)4bitFDHDLAHALɏW߂
                mov     ds,cs:SegB800   ; plane  3  2  1  0 iv32bitj
                mov     dl,ds:[bx]      ;       DH DL AH AL
                mov     ds,cs:SegB000
                mov     ah,ds:[bx]
                mov     ds,cs:SegA800  
                mov     al,ds:[bx]
                pop     ds
                ret
GetVram_DXAX    ENDP
SegA800         DW      0A800h
SegB000         DW      0B000h
SegB800         DW      0B800h
SegE000         DW      0E000h
;---------------------------------------------------------------
;       sPʂ̏F@SaveToFilëꕔ
;---------------------------------------------------------------
GetLine4bit     PROC    near
                mov     P8Count,0       ; 1C̉ʒuJE^ 0-->79
 P8_Entry:  
                xor     ax,ax
                mov     bx,(640/8)
                mov     ax,LineCount    ; 0-->399
                mul     bx              ; 
                add     ax, P8Count     ; vŽ
                mov     bx,ax           ; bx=VRAM ̃ItZbgʒu
                call    GetVram_DXAX
                mov     si,offset Dot8Bit4
                mov     ch,10000000b    ; ch͒bitʒuwwW
                mov     cl,8
ByteTop:        mov     bl,0
                test    DH,ch   ; plane3̃oCgf[^ch̎wbitPȂ
                jz      @f
                or      bl,8    ; bit3210̒lčs
        @@:     test    DL,ch   ; plane2̃oCgf[^ch̎wbitPȂ
                jz      @f
                or      bl,4 
        @@:     test    AH,ch   ; plane1̃oCgf[^ch̎wbitPȂ
                jz      @f
                or      bl,2
        @@:     test    AL,ch   ; plane0̃oCgf[^ch̎wbitPȂ
                jz      @f
                or      bl,1
        @@:                     ; BL00..0F̒l
                mov     ds:[si],bl      ; ܂Dot8Bit4[si]ɕۑ
                inc     si      ; ۑʒuPoCg
                shr     ch,1    ; ̃hbgbitʒuVtg
               Loop     ByteTop ; 8܂킷

                mov     si,offset Dot8Bit4 ; ܍8dot=8byte f[^
                mov     cx,4    ; ̃[v8oCgԂ4܂
EightDotLoopEnt:
                lodsw           ; f[^ǂ݁AʒuQoCgi߂
                xchg    al,ah   ; ㉺iȂꍇk摜Iȉj
;;              and     ah,0Fh  ; Ô4bit}XNiRi΍j
;;              and     al,0Fh  ;       //
                shl     al,4    ; ʑɂSVtgahɌq
                shr     ax,4    ; ̂ƉEɃVtgalɏW܂
                stosb           ; es:diɏ
               loop     EightDotLoopEnt      ; ̃[v8oCgԂ4܂
                inc     P8Count ; WJʒuɐi߂
                cmp     P8Count,(640/8) ; 1CʒuJE^80ȏɂȂΒEo
                jb      P8_Entry
                ret             ; si͔jŖ߂ di͌p
GetLine4bit     ENDP
;---------------------------------------------------------------

;---------------------------------------------------------------
;       SaveToFile
;---------------------------------------------------------------
SaveToFile      PROC    near
                enter   12,0
                mov     dx,offset OutputFileName
                call    _puts
                mov     dx, offset OutputFileName
                mov     cx,0020h        ; VK쐬î𖳏Œׂj
                mov     ax,3C00h        ; ݂ŃI[v
                xor     bx,bx
                int     21h
                jc      creat_err
                mov     DOS_handle,ax
; wb_ƃpbg̏
                mov     bx,DOS_handle
                mov     cx,SizeOfHeaderPal
                mov     dx,offset BitmapHeaderBase
                mov     ah,40h          ; write to file
                int     21h
                jc      write_err
; f[^̏
                mov     LineCount,400           ; ꂩɃXL(BMPdl)
LineOrigin:     dec     LineCount               ; 399C
                mov     di,offset LineBuffer    ; 1C̃obt@ɈʒuÂ
                call    GetLine4bit
                mov     dx,offset LineBuffer    ; 1C̃obt@ɈʒuÂ
                mov     bx,DOS_handle
                mov     dx,offset LineBuffer
                mov     cx, (640/8)*4   ; (320)
                mov     ah,40h          ; write to file 4bit 1 line
                int     21h
                jc      write_err
                cmp     LineCount,0     ; 0CڂɒBEo
                jnz     LineOrigin      ; łȂΌɖ߂
CloseFile:
                mov     bx,DOS_handle
                mov     ah,3Eh          ; CloseFile
                xor     dx,dx
                int     21h
                mov     dx,offset MsgSaved
                call    _puts
                mov     dx,offset CRLF
                call    _puts
                clc
ExitSaveFile:   leave
                ret
creat_err:      mov     dx,offset CreatErrMsg
                call    _puts
                stc
                jmp     ExitSaveFile
write_err:      mov     dx,offset WriteErrMsg
                jmp     CloseAbort
data_err:       mov     dx,offset DataErrMsg
                jmp     CloseAbort
CloseAbort:     call    _puts
                mov     bx,DOS_handle
                mov     ah,3Eh          ; CloseFile
                xor     dx,dx
                int     21h
                stc
                jmp     ExitSaveFile
MsgSaved        DB "  t@C쐬܂. ",13,10,0
CreatErrMsg     DB "  t@C̍쐬Ŏs܂. ",13,10,0
WriteErrMsg     DB "  t@C݂Ŏs܂.",13,10,0
DataErrMsg      DB "  f[^G[ł."
;MsgLoaded       DB "  t@CǍ݂܂. ",13,10,0
;OpenErrMsg      DB "  t@C̃I[vŎs܂. ",13,10,0
;ReadErrMsg      DB "  t@CǍ݂Ŏs܂.",13,10,0
SaveToFile      ENDP

;--------------------------------------------------------------------------
;       machine_check   
;--------------------------------------------------------------------------
machine_check   PROC   near     
                mov     ah,00
                mov     cx,0FFFFh       ; 悭mꂽ98/AT`FbN
                int 1Ah
                cmp     cx,0FFFFh
                jNE     NotPC98  
;                mov     dx,offset msg_copyright ; o[W\LA
;                call    _puts
                clc
                ret
NotPC98:        
                mov     dx,offset msg_not98
                call    _puts  ; int 21ŕ\
                stc
                ret
machine_check   ENDP
;--------------------------------------------------------------
;-----------------------------------------------------------------
;       _puts in MS-DOS
;-----------------------------------------------------------------
_puts           PROC    near
                pusha
                mov     bx,dx
_puts_ent:      cmp     byte ptr [bx],0
                jz      @f
                inc     bx
                jmp     _puts_ent
        @@:     mov     byte ptr [bx],'$'
                mov     ah,9
                int 21h
                mov     byte ptr [bx],0
                popa
                ret
_puts           ENDP
;--------------------------------------------------------------
SavePalette16   PROC   near
                mov     cx,0
                mov     bl,17
                mov     di,offset PaletteTable98
                push    ds
                pop     es      ; es=ds
SavePaletteEnt:
                mov     al,cl
                out     0A8h,al
                out     05Fh,al   ; ԑ҂Kvǂs
                stosb
                in      al,0AAh
                out     05Fh,al
                mul     bl
                stosb
                in      al,0ACh
                out     05Fh,al
                mul     bl
                stosb
                in      al,0AEh
                out     05Fh,al
                mul     bl
                stosb
                inc     cl
                cmp     cl,16
                jb      SavePaletteEnt
;                mov     di,offset PaletteTable98
                ret
SavePalette16   ENDP

;--------------------------- 2021.2.26 ǉ --- 400line  GRCG
ginit           PROC   near
;                mov     ah,40h          ; ʕ\Jn
;                int 18h

;                mov     ah,42h          ; 400C[h BIOS
;                mov     ch,0C0h         ; inC]ł͎gȂj
;                int 18h

;                mov     al,08h        ; 400C[h I/O i@݊j
;                out     68h,al        ; inC]ł͎gȂj

;                mov     al,01h          ; OtBbN16F[h
;                out     6Ah,al

                mov     al,41h          ;̨ʂ÷ĉʂ̃Y
                out     6Ah,al

                mov     al,00000000b    ; GRCG, TDW, 00,4planeL=0
                out     7Ch,al          ; GRCG [hŐݒ

                call    init_palette8

                ret
ginit           ENDP

;--------------------------- 2023.1.4 ǉ --- 936line  GRCG
if 0
ginitH          PROC   near
                mov     al,0Dh
                out     0A2h,al
                mov     al,00000000b    ; GRCG, TDW, 00,4planeL=0
                out     0A4h,al          ; GRCG [hŐݒ
                ret
ginitH          ENDP
endif
;------------------------------------
init_palette8   PROC   near
            mov     al,0
            out     0A8h,al
            mov     al,00
            out     0AAh,al
            mov     al,00
            out     0ACh,al
            mov     al,00
            out     0AEh,al

            mov     al,01
            out     0A8h,al
            mov     al,00
            out     0AAh,al
            mov     al,00
            out     0ACh,al
            mov     al,0Fh
            out     0AEh,al

            mov     al,02
            out     0A8h,al
            mov     al,00
            out     0AAh,al
            mov     al,0Fh
            out     0ACh,al
            mov     al,00
            out     0AEh,al

            mov     al,03
            out     0A8h,al
            mov     al,00
            out     0AAh,al
            mov     al,0Fh
            out     0ACh,al
            mov     al,0Fh
            out     0AEh,al

            mov     al,04
            out     0A8h,al
            mov     al,0Fh
            out     0AAh,al
            mov     al,00
            out     0ACh,al
            mov     al,00
            out     0AEh,al

            mov     al,05
            out     0A8h,al
            mov     al,0Fh
            out     0AAh,al
            mov     al,00
            out     0ACh,al
            mov     al,0Fh
            out     0AEh,al

            mov     al,06
            out     0A8h,al
            mov     al,0Fh
            out     0AAh,al
            mov     al,0Fh
            out     0ACh,al
            mov     al,00
            out     0AEh,al

            mov     al,07
            out     0A8h,al
            mov     al,0Fh
            out     0AAh,al
            mov     al,0Fh
            out     0ACh,al
            mov     al,0Fh
            out     0AEh,al

            mov     al,08
            out     0A8h,al
            mov     al,00
            out     0AAh,al
            mov     al,00
            out     0ACh,al
            mov     al,00
            out     0AEh,al

            mov     al,09
            out     0A8h,al
            mov     al,00
            out     0AAh,al
            mov     al,00
            out     0ACh,al
            mov     al,0Fh
            out     0AEh,al

            mov     al,0Ah
            out     0A8h,al
            mov     al,00
            out     0AAh,al
            mov     al,0Fh
            out     0ACh,al
            mov     al,00
            out     0AEh,al

            mov     al,0Bh
            out     0A8h,al
            mov     al,00
            out     0AAh,al
            mov     al,0Fh
            out     0ACh,al
            mov     al,0Fh
            out     0AEh,al

            mov     al,0Ch
            out     0A8h,al
            mov     al,0Fh
            out     0AAh,al
            mov     al,00
            out     0ACh,al
            mov     al,00
            out     0AEh,al

            mov     al,0Dh
            out     0A8h,al
            mov     al,0Fh
            out     0AAh,al
            mov     al,00
            out     0ACh,al
            mov     al,0Fh
            out     0AEh,al

            mov     al,0Eh
            out     0A8h,al
            mov     al,0Fh
            out     0AAh,al
            mov     al,0Fh
            out     0ACh,al
            mov     al,00
            out     0AEh,al

            mov     al,0Fh
            out     0A8h,al
            mov     al,0Fh
            out     0AAh,al
            mov     al,0Fh
            out     0ACh,al
            mov     al,0Fh
            out     0AEh,al
            ret     
init_palette8   ENDP

DefaultPalette16        label   word
       DB       0,      0,      0,      0
       DB       1,    255,      0,      0
       DB       2,      0,    255,      0
       DB       3,    255,    255,      0
       DB       4,      0,      0,    255
       DB       5,    255,      0,    255
       DB       6,      0,    255,    255
       DB       7,    255,    255,    255
       DB       8,     64,     64,     64
       DB       9,    127,      0,      0
       DB      10,      0,    127,      0
       DB      11,    127,    127,      0
       DB      12,      0,      0,    127
       DB      13,    127,      0,    127
       DB      14,      0,    127,    127
       DB      15,    127,    127,    127

CheckPal        PROC   near
                xor     bx,bx
                mov     si,offset PaletteTable98
                mov     cx,(16*2)
    Ent16loop:
                lodsw   
                mov     al,0EFh
                mov     dx,ax
                lodsw   
                cmp     dx,0EFEFh
                jne     @f
                cmp     ax,0EFEFh
                jne     @f
                inc     bx
        @@:     
               loop     Ent16loop
                or      bx,bx
                jz      @f
                mov     cx,(16*2)
                mov     si,offset offset DefaultPalette16
                mov     di,offset offset PaletteTable98
                push    ds
                pop     es
        rep     movsw
                
        @@:
                ret
CheckPal        ENDP
;------------------------------------
align 16         ; ȉ̂R̍\̂͘AzułȂ΂ȂȂ
.386
BitmapHeaderBase        label   byte
BF_head BitmapFileHeader <4D42h, (14+40+4*16)+DATA_BYTE_SIZE, 0, 14+40+4*16,0 >
BI_head BitmapInfoHeader <40,640,400,1,4,0,(DATA_BYTE_SIZE),0,0,16,16>
PAL16   DD      16 dup(0)       ; R͘AzułȂ΂ȂȂ
.186

; 񏉊ϐ
PaletteTable98  label   byte    
                DD      16 dup (?)      ; 9816FpbgǂݏoĂꏊ
Dot8Bit4        DB      8 dup(?)        ; 32bitWX^gpΕsv...
LineBuffer      DB      (640) dup  (?)

StackBase       label   byte




code    ends
        end     start
