;       Version 1.20
;---------------------------------------------------------------
MakeTileReg     PROC   near
                push    ax
                pushf
                cli
                mov     al,000h
                test    ColorBits,1
                jz      @f
                mov     al,0FFh
       @@:      out     7Eh,al
                mov     al,000h
                test    ColorBits,2
                jz      @f
                mov     al,0FFh
       @@:      out     7Eh,al
                mov     al,000h
                test    ColorBits,4
                jz      @f
                mov     al,0FFh
       @@:      out     7Eh,al
                mov     al,000h
                out     7Eh,al
                popf
                pop     ax
                ret
MakeTileReg     ENDP
;------------------------------------------------------

CGW_Zenkaku8    PROC   near     ;    Sp̏
                mov     di,0
                mov     LineCount,0
                xchg    al,ah           ; eLXĝƂ̋t    
                out     0A1h,al         ; Low
                xchg    al,ah
                out     0A3h,al         ; EHigh
charHtop:       mov     al,LineCount
                or      al,20h          ; line #0 left data
                out     0A5h,al
                in      al,0A9h
                mov     DL,al           ; DLɒ~
                mov     al,LineCount
                or      al,00h          ; line #0 right data
                out     0A5h,al
                in      al,0A9h
                mov     DH,al           ; DHɒ~
                test    Attrib,00000100b ; ]rbg
                jz      @f
                not     dx              ; ]
        @@:     

                test    Attrib,00010000b ; deleteCrbg
                jz      @f
                or     dx,0000100000001000b       ; deleteC
        @@:

                test    Attrib,00001000b ; A_[Crbg
                jz      @f
                cmp     LineCount,15
                jne     @f
                mov     DL,55h         ; 0FFh    ; C
        @@:     
                call    MakeTileReg
                mov     es:[bx+di],DL   ; o
                inc     LineCount       
                add     di,640/8        ; PCVRAMoCginC]ύXj
                cmp     LineCount,16    ; cCinC]ύXj
                jb      charHtop
                ret
CGW_Zenkaku8    ENDP
;------------------------------------------------------

CGW_Zenkaku16   PROC   near     ;    Sp̏
                mov     di,0
                mov     LineCount,0
                xchg    al,ah           ; eLXĝƂ̋t    
                out     0A1h,al         ; Low
                xchg    al,ah
                out     0A3h,al         ; EHigh
char2top:       mov     al,LineCount
                or      al,20h          ; line #0 left data
                out     0A5h,al
                in      al,0A9h
                mov     DL,al           ; DLɒ~
                mov     al,LineCount
                or      al,00h          ; line #0 right data
                out     0A5h,al
                in      al,0A9h
                mov     DH,al           ; DHɒ~
                test    Attrib,00000100b ; ]rbg
                jz      @f
                not     dx              ; ]
        @@:     

                test    Attrib,00010000b ; deleteCrbg
                jz      @f
                or     dx,0000100000001000b       ; deleteC
        @@:

                test    Attrib,00001000b ; A_[Crbg
                jz      @f
                cmp     LineCount,15
                jne     @f
                mov     dx,05555h             ; 0FFFFh    ; C
        @@:     
                call    MakeTileReg
                mov     es:[bx+di],dx   ; o
                inc     LineCount       
                add     di,640/8        ; PCVRAMoCginC]ύXj
                cmp     LineCount,16    ; cCinC]ύXj
                jb      char2top
                ret
CGW_Zenkaku16   ENDP
;----------------------------------------------------------------------------
CGW_Hankaku16   PROC   near     ;  p̏i98ˑpQoCg͑ΏۊOj
                mov     di,0
                mov     LineCount,0

IFDEF   OLD98
Char1Top:       
                push    bx
                mov     bl,LineCount
                mov     bh,0
                add     bx,AnkFontPointer
                mov     al,ds:[bx]         ; ALɒ~
                pop     bx
ELSE
                xchg    al,ah
                out     0A1h,al
                xchg    al,ah
                out     0A3h,al
Char1Top:       mov     al,LineCount
                or      al,20h          ; line #0 left data
                out     0A5h,al
                in      al,0A9h         ; ALɒ~
ENDIF
                test    Attrib,00000100b ; ]rbg
                jz      @f
                not     al
        @@:     
                test    Attrib,00010000b ; deleteCrbg
                jz      @f
                or      al,00001000b     ; deleteC
        @@:
                test    Attrib,00001000b ; A_[Crbg
                jz      @f
                cmp     LineCount,15
                jne     @f
                mov     al,055h     ; 0FFh  ;C
        @@:
                call    MakeTileReg
                mov     es:[bx+di],al
                inc     LineCount
                add     di,(640/8)      ; PCVRAMoCginC]ύXj
                cmp     LineCount,16    ; cCinC]ύXj
                jb      Char1Top
                ret
CGW_Hankaku16   ENDP

;-----------------------------------------------------------------------------
Text2GVRAM    PROC   near
IFDEF   OLD98
                SetPalette 0,0,9,0
ENDIF
                mov     ax,TVRAMseg     ; DS=eLXgVRAM
                mov     ds,ax
                mov     ax,GVRAMseg     ; ES=OtBbNVRAM
                mov     es,ax
                xor     ax,ax
                mov     bx,ax
                mov     di,ax
                mov     si,ax
                mov     bx,ax
                mov     RowG,ax
                  LineEnt:
                  mov   ColumnG,0

IFDEF   OLD98
                mov     al,6
                out     37h,al
                mov     cx,100h
      @@:       out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
              loop @b
                mov     al,7
                out     37h,al
ENDIF
                  mov   ax,640/8*16     ; PCoCginC]ł͕ύXj
                  mul   RowG             ; s{
                  mov   bx,ax           ; BX=eLXgs[GVRAMʒu

                    CharEnt:
                    mov     ax,RowG      ; eLXgsʒu
                    mov     cx,80       ; ̂WO{inC]ł͕ύXj
                    mul     cx          ;
                    add     ax,ColumnG      ; ɃJʒu𑫂
                    shl     ax,1        ; Q{
                    mov     si,ax       ; si̓eLXgVRAM̕ʒu
                    mov     ax,ds:[si+2000h]  ; Agr[gǂ
                    mov     dl,al       ; z
                    and     dl,1Fh      ; F̓Jbg
                    mov     Attrib,dl   ; i]^񔽓]j
                    shr     al,5        
                    mov     ColorBits,al ; F3bito 0..7
                    mov     ax,ds:[si]  ; P[hǂݏo
                    cmp     ah,00h      ; ʃoCg[Ȃ甼p
                    jz      Hankaku
                    cmp     al,0Bh      ; ʃoCg2Bxxh-20xxh=0BxxhȂ甼p2byte
                    je      Hankaku2B
                    cmp     al,0Ah      ; ʃoCg2Axxh-20xxh=0AxxhȂ甼p2byte
                    je      Hankaku2B
                    cmp     al,09h      ; ʃoCg29xxh-20xxh=09xxhȂ甼p2byte
                    je      Hankaku2B
;Zenkaku:            
                    call    CGW_Zenkaku16 ; Sp̏
                    inc     ColumnG         ; SpȂPɐi߂
                    inc     bx          ; GVRAMʒui߂
                    jmp     ZenHan
Hankaku2B:          call    CGW_Zenkaku8 ; 1/2p̏
                    jmp     ZenHan
Hankaku:            
ifdef   OLD98
                    push        ax
                    push        bx
                    push        cx
                    push        dx
                    mov     dl,al
                    mov     bx,ds
                    mov     cx,AnkFontPointer
                    sub     cx,2
                    mov     DH,80h
                    mov     AH,14h
                    int     18h
                    mov     al,0Bh
                    out     68h,al
                    pop         dx
                    pop         cx
                    pop         bx
                    pop         ax
ENDIF
                    call    CGW_Hankaku16 ; p̏

ZenHan:             inc     ColumnG         ; SppƂPɐi߂
                    inc     bx          ; GVRAMʒu, ʑSp͂Q
                    cmp     ColumnG,80      ; 80JɒB
                    jb      CharEnt     ; BĂȂԂ͉


                  inc   RowG
                  cmp   RowG,MAX_LINES
                  jb    LineEnt
IFDEF   OLD98
                SetPalette 0,0,0,0
ENDIF
                ret
Text2GVRAM      ENDP
;-------------------------------------
ginit_GRCG      PROC   near
                mov     al,0Bh
                out     68h,al
                push    ds
                xor     ax,ax
                mov     dx,ax
                mov     al,byte ptr ds:[0495h] ; GRCGgptO
                mov     cs:GRCGmode,al          ; ۑ
                or      al,80h
                or      byte ptr ds:[0495h],al ; GRCGgptO𗧂Ă
                pop     ds
                mov     al,10001000b    ; GRCGL, TDW, 00,4planeL=0
                out     7Ch,al           ; GRCG [hɈڂ
                xor     ax,ax
                mov     di,ax
                mov     al,0h         ; x^
                out     7Eh,al           ; GRCG tile plane#0
                out     5Fh,al
                out     7Eh,al           ; GRCG tile plane#1
                out     5Fh,al
                out     7Eh,al           ; GRCG tile plane#2
                out     5Fh,al
                out     7Eh,al           ; GRCG tile plane#3
                out     5Fh,al
                mov     cx,8000h/2
                mov     ax,0A800h
                mov     es,ax
                mov     ax,0
         rep    stosw
                mov     al,11000000b    ; GRCGL, TDW, 00,4planeL=0
                out     7Ch,al           ; GRCG [hɈڂ
                ret
ginit_GRCG      ENDP
;-------------------------------------
gterm_GRCG      PROC   near
                mov     al,0Ah
                out     68h,al          ; R[hANZX[h
                mov     al,cs:GRCGmode
                test    al,80h          ; GRCGgptO
                jnz     ModeIsGRCG      ; ΂̂܂܁AȂ
                mov     al,00001111b    ; GRCG, TDW, 00,4planeL
                out     7Ch,al          ; CPUANZX[hɖ߂
ModeIsGRCG:     
                xor     ax,ax
                push    ds
                mov     ds,ax
                and     byte ptr ds:[0495h],7Fh ; GRCGgptO
                pop     ds
                ret
gterm_GRCG      ENDP
;------------------------------------------------------------------
CopyTG_main     PROC   near
                enter   20,0    ; X^bNϐgpJn
                mov     AnkFontPointer,1400h    ; (80*32*2)
                push    es
                call    ginit_GRCG  ; OtBbNGRCGgpJn
                push    ds
                call    Text2GVRAM
                pop     ds
                call    gterm_GRCG   ; OtBbNGRCGgpI
                pop     es
                leave           ; X^bNϐ
                ret
CopyTG_main     ENDP
;------------------------------------------------------------------

